package com.its.op.service.its.code;

import com.its.op.dao.repository.its.code.TbSectGradRepository;
import com.its.op.dto.its.code.TbSectGradClsfDto;
import com.its.op.entity.its.code.TbSectGrad;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbSectGradService {

    private final TbSectGradRepository repo;

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbSectGradClsfDto> findAll() {
        List<TbSectGradClsfDto> result = new ArrayList<>();
        List<TbSectGrad> data = this.repo.findAll();
        for (TbSectGrad entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbSectGradClsfDto> mergeInfoList(List<TbSectGradClsfDto.TbSectGradClsfUpdReq> reqList) {
        List<TbSectGradClsfDto> result = new ArrayList<>();
        for (TbSectGradClsfDto.TbSectGradClsfUpdReq req : reqList) {
            TbSectGrad obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbSectGradClsfDto mergeInfo(TbSectGradClsfDto.TbSectGradClsfUpdReq req) {
        TbSectGrad obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbSectGradClsfDto> deleteByIds(List<String> ids) {
        List<TbSectGradClsfDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbSectGrad> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
